summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorLars Wirzenius <lars.wirzenius@codethink.co.uk>2012-05-15 23:30:46 +0300
committerLars Wirzenius <lars.wirzenius@codethink.co.uk>2012-05-15 23:30:46 +0300
commitc19502cb7e9fab6838b4d3e059f28fc459560667 (patch)
tree2345860d7d2dd880ac6aa4c6cc868a4830a23cde /tests
parent7592555e581f9b22ce2e699799d255d90cf2bab4 (diff)
parent21da7c08dc4c513ff327328d8e81e235616ad996 (diff)
downloadmorph-c19502cb7e9fab6838b4d3e059f28fc459560667.tar.gz
Merge branch 'master' of gitorious.org:baserock/morph
Diffstat (limited to 'tests')
-rwxr-xr-xtests/stratum-overlap-keeps-directory-links.script32
l---------tests/stratum-overlap-keeps-directory-links.setup1
-rwxr-xr-xtests/stratum-overlap-stomps-file-links.script32
l---------tests/stratum-overlap-stomps-file-links.setup1
-rwxr-xr-xtests/stratum-overlap-warns.script28
-rwxr-xr-xtests/stratum-overlap-warns.setup113
-rw-r--r--tests/stratum-overlap-warns.stdout5
7 files changed, 212 insertions, 0 deletions
diff --git a/tests/stratum-overlap-keeps-directory-links.script b/tests/stratum-overlap-keeps-directory-links.script
new file mode 100755
index 00000000..a995194f
--- /dev/null
+++ b/tests/stratum-overlap-keeps-directory-links.script
@@ -0,0 +1,32 @@
+#!/bin/sh
+#
+# If a stratum has symbolic links pointing to files, then the symlink
+# should be removed and replaced by that file
+#
+# Copyright (C) 2011, 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+set -eu
+
+cache="$DATADIR/cache/artifacts"
+extracted="$DATADIR/extracted"
+mkdir -p "$extracted"
+
+"$SRCDIR/scripts/test-morph" \
+ build test:morphs-repo overlap overlap-stratum.morph
+for f in "$cache"/*.stratum.overlap-stratum; do
+ tar -xf "$f" -C "$extracted"
+done
+test -h "$extracted/usr"
diff --git a/tests/stratum-overlap-keeps-directory-links.setup b/tests/stratum-overlap-keeps-directory-links.setup
new file mode 120000
index 00000000..255e9a74
--- /dev/null
+++ b/tests/stratum-overlap-keeps-directory-links.setup
@@ -0,0 +1 @@
+stratum-overlap-warns.setup \ No newline at end of file
diff --git a/tests/stratum-overlap-stomps-file-links.script b/tests/stratum-overlap-stomps-file-links.script
new file mode 100755
index 00000000..0d429bbf
--- /dev/null
+++ b/tests/stratum-overlap-stomps-file-links.script
@@ -0,0 +1,32 @@
+#!/bin/sh
+#
+# If a stratum has symbolic links pointing to files, then the symlink
+# should be removed and replaced by that file
+#
+# Copyright (C) 2011, 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+set -eu
+
+cache="$DATADIR/cache/artifacts"
+extracted="$DATADIR/extracted"
+mkdir -p "$extracted"
+
+"$SRCDIR/scripts/test-morph" \
+ build test:morphs-repo overlap overlap-stratum.morph
+for f in "$cache"/*.stratum.overlap-stratum; do
+ tar -xf "$f" -C "$extracted"
+done
+test -f "$extracted/bin/foo"
diff --git a/tests/stratum-overlap-stomps-file-links.setup b/tests/stratum-overlap-stomps-file-links.setup
new file mode 120000
index 00000000..255e9a74
--- /dev/null
+++ b/tests/stratum-overlap-stomps-file-links.setup
@@ -0,0 +1 @@
+stratum-overlap-warns.setup \ No newline at end of file
diff --git a/tests/stratum-overlap-warns.script b/tests/stratum-overlap-warns.script
new file mode 100755
index 00000000..edb1d855
--- /dev/null
+++ b/tests/stratum-overlap-warns.script
@@ -0,0 +1,28 @@
+#!/bin/sh
+#
+# If a stratum has multiple chunks that have the same files in them,
+# then this should be notified
+#
+# Copyright (C) 2011, 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+set -eu
+
+log="$DATADIR/morph.log"
+cache="$DATADIR/cache/artifacts"
+
+"$SRCDIR/scripts/test-morph" \
+ build --log=$log test:morphs-repo overlap overlap-stratum.morph
+grep WARNING $log | sed 's/^.*WARNING/WARNING/'
diff --git a/tests/stratum-overlap-warns.setup b/tests/stratum-overlap-warns.setup
new file mode 100755
index 00000000..94aed05a
--- /dev/null
+++ b/tests/stratum-overlap-warns.setup
@@ -0,0 +1,113 @@
+#!/bin/sh
+#
+# If a stratum has multiple chunks that have the same files in them,
+# then this should be notified
+#
+# Copyright (C) 2011, 2012 Codethink Limited
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+set -eu
+
+chunkrepo="$DATADIR/chunk-repo"
+morphsrepo="$DATADIR/morphs-repo"
+
+cd "$morphsrepo"
+git checkout --quiet -b overlap master
+cat <<EOF >overlap-stratum.morph
+{
+ "name": "overlap-stratum",
+ "kind": "stratum",
+ "sources": [
+ {
+ "name": "dirs",
+ "repo": "test:chunk-repo",
+ "ref": "overlap"
+ },
+ {
+ "name": "overlap-foobar",
+ "repo": "test:chunk-repo",
+ "ref": "overlap"
+ },
+ {
+ "name": "overlap-fooqux",
+ "repo": "test:chunk-repo",
+ "ref": "overlap"
+ },
+ {
+ "name": "overlap-foo-baz",
+ "repo": "test:chunk-repo",
+ "ref": "overlap"
+ }
+ ]
+}
+EOF
+git add overlap-stratum.morph
+git commit --quiet -m "add overlapping stratum"
+
+cd "$chunkrepo"
+git checkout --quiet -b overlap master
+
+cat <<EOF >dirs.morph
+{
+ "name": "dirs",
+ "kind": "chunk",
+ "install-commands": [
+ "mkdir -p \$DESTDIR/bin",
+ "ln -s / \$DESTDIR/usr"
+ ]
+}
+EOF
+git add dirs.morph
+
+cat <<EOF >overlap-foo-baz.morph
+{
+ "name": "overlap-foo-baz",
+ "kind": "chunk",
+ "install-commands": [
+ "mkdir -p \$DESTDIR/bin",
+ "for f in foo bar baz; do echo echo \$f >\$DESTDIR/bin/\$f; done"
+ ]
+}
+EOF
+git add overlap-foo-baz.morph
+
+cat <<EOF >overlap-foobar.morph
+{
+ "name": "overlap-foobar",
+ "kind": "chunk",
+ "install-commands": [
+ "mkdir -p \$DESTDIR/usr/bin \$DESTDIR/bin",
+ "echo echo foobar >\$DESTDIR/usr/bin/foobar",
+ "ln -s /usr/bin/foobar \$DESTDIR/bin/foo",
+ "ln -s /usr/bin/foobar \$DESTDIR/bin/bar"
+ ]
+}
+EOF
+git add overlap-foobar.morph
+
+cat <<EOF >overlap-fooqux.morph
+{
+ "name": "overlap-fooqux",
+ "kind": "chunk",
+ "install-commands": [
+ "mkdir -p \$DESTDIR/usr/bin \$DESTDIR/bin",
+ "for f in qux fooqux; do echo echo \$f >\$DESTDIR/usr/bin/\$f; done",
+ "ln -s /usr/bin/fooqux \$DESTDIR/bin/foo"
+ ]
+}
+EOF
+git add overlap-fooqux.morph
+
+git commit --quiet -m 'Add overlapping chunks'
diff --git a/tests/stratum-overlap-warns.stdout b/tests/stratum-overlap-warns.stdout
new file mode 100644
index 00000000..eaddf9c1
--- /dev/null
+++ b/tests/stratum-overlap-warns.stdout
@@ -0,0 +1,5 @@
+WARNING Overlaps in artifact overlap-stratum detected
+WARNING Artifacts overlap-foo-baz, overlap-foobar overlap with files:
+WARNING bin/bar
+WARNING Artifacts overlap-foo-baz, overlap-foobar, overlap-fooqux overlap with files:
+WARNING bin/foo